local addonName = " |cffCE5C00Lemmo\'s|r |cff729FCFExperience|r|cff73D216 Bar|r"
local LEXB_Version = "4.2"
local lexf_optionsFrame = CreateFrame("FRAME")

local lexf_wowv = 0

local _, _, _, lexf_tocver = GetBuildInfo()
if lexf_tocver < 20000 then
    lexf_wowv = 1
elseif lexf_tocver > 20000 and lexf_tocver <30000 then
    lexf_wowv = 2
elseif lexf_tocver > 30000 and lexf_tocver <40000 then
    lexf_wowv = 3
elseif lexf_tocver >= 100000 then
    lexf_wowv = 10
end

if GetLocale() == "frFR"
then
	lexf_txt_amaxxp = "Expérience actuelle/maximale:"
	lexf_txt_pnl = "Pointe vers le niveau suivant: "
	lexf_txt_ehpct = "Reposée:"
	lexf_txt_ehpt = "Expérience bonus disponible:"
	lexf_txt_otherchars = "Autres personnages:"
	lexf_txt_maxreached = "Niveau maximum atteint."
	lexf_txt_reset = "Réinitialiser les options"
	lexf_txt_resetdesc = "Réinitialise tous les paramètres utilisateur pour ce caractère.\nL'interface utilisateur redémarrera automatiquement.\n\nCette fonction est très utile si la barre d'expérience est\naccidentellement déplacée hors de la zone visible de l'écran."
	lexf_txt_lock = "Position fixe."
	lexf_txt_lockdesc = "Empêche la barre d'expérience d'être déplacée accidentellement."
	lexf_txt_show = "Afficher la barre d'expérience."
	lexf_txt_showdesc = "Affichez ou masquez la barre d'expérience."
    lexf_txt_showpet = "Afficher la barre d'expérience du compagnon.\n(Chasseurs uniquement et pas dans Retail.)"
	lexf_txt_showpetdesc = "Afficher ou masquer la barre d'expérience du compagnon ."
	lexf_txt_clearcache = "Vider le cache"
	lexf_txt_clearcachedesc = "Toutes les données de personnage collectées seront supprimées.\n\n!!! Attention, cette action est irréversible !!!"
	lexf_txt_cronly = "Seuls les personnages du royaume actuel."
	lexf_txt_cronlydesc = "L'info-bulle n'affiche que les informations des personnages du royaume actuel.\nCeci est utile si vous avez trop de caractères pour le gérer dans l'info-bulle."
	lexf_txt_confirmdel = "Êtes-vous sûr de supprimer toutes les données enregistrées?\n\n!!! Mise en garde! Cela ne peut pas être inversé. !!!"
	lexf_txt_h2go = "Complètement reposé en:"
    lexf_txt_ttsize = "Taille de l'info-bulle: "
    lexf_txt_ttsizedesc = "Modifier la taille de l'info-bulle "
    lexp_txt_petttexp = "Expérience des compagnons:"
    lexp_txt_petttloyality = "Fidélité des compagnons:"
    lexp_txt_petgets = " gagne "
    lexp_txt_petexppoints = " points d'experience."
    lexp_txt_petmobs2go = " adversaires au niveau supérieur."
    lexp_txt_petcongrats = "Félicitations!!! "
    lexp_txt_petreached1 = " a atteint le niveau "
    lexp_txt_petreached2 = " ."
elseif GetLocale() == "deDE"
then
	lexf_txt_amaxxp = "Aktuelle/maximale Erfahrung:"
	lexf_txt_pnl = "Erfahrungspunkte zum nächsten Level:"
	lexf_txt_ehpct = "Erholt zu:"
	lexf_txt_ehpt = "Verfügbare Bonuspunkte:"
	lexf_txt_otherchars = "Andere Charaktere:"
	lexf_txt_maxreached = "Maximallevel erreicht."
	lexf_txt_reset = "Einstellungen zurücksetzen"
	lexf_txt_resetdesc = "Setzt alle Oberflächeneinstellungen zurück.\nEs werden nur die Einstellungen für den aktuellen Charakter zurückgesetzt.\nDas Benutzerinterface wird dazu automatisch neu gestartet!\n\nDiese Funktion ist sehr hilfreich bei einem versehentlichen Verschieben\nder Experience Bar außerhalb des sichtbaren Bereichs des Bildschirms."
	lexf_txt_lock = "Position festsetzen."
	lexf_txt_lockdesc = "Verhindert, dass die Experience Bar aus versehen verschoben wird."
	lexf_txt_show = "Experience Bar anzeigen."
	lexf_txt_showdesc = "Anzeigen oder Verstecken der Experience Bar."
    lexf_txt_showpet = "Begleiter-Erfahrungsleiste anzeigen.\n(Nur Jäger und nicht in Retail)"
	lexf_txt_showpetdesc = "Anzeigen oder Verstecken der Begleiter-Erfahrungsleiste."
	lexf_txt_clearcache = "Cache löschen"
	lexf_txt_clearcachedesc = "Alle gesammelten Informationen über Charaktere werden gelöscht.\n\n!!! Achtung, dies kann nicht rückgängig gemacht werden !!!"
	lexf_txt_cronly = "Nur Charaktere des aktuellen Realms Anzeigen."
	lexf_txt_cronlydesc = "Es werden im Tooltip nur die Informationen über Charaktere dieses Realms angezeigt.\nDies kann helfen, wenn Ihr zu viele charaktere gleichzeitig levelt und das die Kapazität des Tooltips sprengt."
	lexf_txt_confirmdel = "Sollen wirklich alle gespeicherten Daten gelöscht werden?\n\n!!! Achtung dies kann nicht rückgängig gemacht werden !!!"
	lexf_txt_h2go = "Vollkommen ausgeruht in:"
    lexf_txt_ttsize = "Tooltip-Größe: "
    lexf_txt_ttsizedesc = "Anpassung der Größe des Tooltips"
    lexp_txt_petttexp = "Tier-Erfahrung:"
    lexp_txt_petttloyality = "Tier-Treue:"
    lexp_txt_petgets = " gewinnt "
    lexp_txt_petexppoints = " Erfahrung. Noch "
    lexp_txt_petmobs2go = " Gegner zum nächsten Level."
    lexp_txt_petcongrats = "Glückwunsch!!! "
    lexp_txt_petreached1 = " hat Level "
    lexp_txt_petreached2 = " erreicht."
else
	lexf_txt_amaxxp = "Current/max. experience:"
	lexf_txt_pnl = "Experience points to level up:"
	lexf_txt_ehpct = "Rested:"
	lexf_txt_ehpt = "Bonus experience available:"
	lexf_txt_otherchars = "Other characters:"
	lexf_txt_maxreached = "Maximum level reached."
	lexf_txt_reset = "Reset settings"
	lexf_txt_resetdesc = "Resets all user settings for this character.\nThe user interface will automatically restart.\n\nThis function is very useful if the Experience Bar is\naccidentally moved outside of the visible area of the screen. "
	lexf_txt_lock = "Fix position."
	lexf_txt_lockdesc = "Prevents the Experience Bar from being accidentally moved."
	lexf_txt_show = "Show Experience Bar."
	lexf_txt_showdesc = "Show or hide the Experience Bar."
    lexf_txt_showpet = "Show pet Experience Bar.\n(Hunters only and not in retail.) "
	lexf_txt_showpetdesc = "Show or hide the pet Experience Bar."
	lexf_txt_clearcache = "Clear cache"
	lexf_txt_clearcachedesc = "All collected character data will be deleted.\n\n!!! Caution, this action is irreversible !!!"
	lexf_txt_cronly = "Only characters on the current realm."
	lexf_txt_cronlydesc = "The tool tip only shows informations for charakters on the current realm.\nThis is helpfull, if you have too many characters to handle it in the tool tip."
	lexf_txt_confirmdel = "Are you sure to delete all saved data?\n\n!!! Caution! This cannot be reversed. !!!"
	lexf_txt_h2go = "Fully rested in:"
    lexf_txt_ttsize = "Tooltip scale: "
    lexf_txt_ttsizedesc = "Change the size of the tooltip"
    lexp_txt_petttexp = "Pet-Experience:"
    lexp_txt_petttloyality = "Pet-Loyalty:"
    lexp_txt_petgets = " gains "
    lexp_txt_petexppoints = " experience. "
    lexp_txt_petmobs2go = " kills to level up."
    lexp_txt_petcongrats = "Congratulations!!! "
    lexp_txt_petreached1 = " reached level "
    lexp_txt_petreached2 = " ."
end


local lexf_MainFrame = CreateFrame("FRAME")
--lexf_MainFrame:SetFrameLevel(4)
local lexf_uiscale = tonumber(GetCVar("uiScale"))
local lexf_uiscaleon = tonumber(GetCVar("useUiScale"))
local lexf_fontsize = 12

local lexf_save_restinside = (5/(8*3600))
local lexf_save_restoutside = (5/(32*3600))
local lexf_maxplayerlevel = 60

if (lexf_wowv == 1) then
    lexf_maxplayerlevel = 60
end

if (lexf_wowv == 2) then
    lexf_maxplayerlevel = 70
end

if (lexf_wowv == 3) then
    lexf_maxplayerlevel = 80
end

if (lexf_wowv == 10) then
    lexf_maxplayerlevel = 60
end

local lexf_expframe = CreateFrame("StatusBar", "Exp-frame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
lexf_expframe:SetSize(160,14)
lexf_expframe:SetOrientation("Horizontal")
lexf_expframe:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
lexf_expframe:SetStatusBarColor(0, 1, 1)
lexf_expframe:SetMinMaxValues(-1,100)
lexf_expframe:SetScript("OnEnter", function(self, motion)
    lexf_GttCurrScale=GameTooltip:GetScale()
    lexf_tooltip()
    end)
lexf_expframe:SetScript("OnLeave", function(self, motion)
    GameTooltip:Hide()
    GameTooltip:SetScale(lexf_GttCurrScale)
    end)
lexf_expframe:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"});
lexf_expframe:EnableMouse(true)

lexf_expframe:SetScript("OnMouseDown", function(self, button)
        if lexf_expframe:IsMovable() then
            if button == "LeftButton" and not self.isMoving then
                self:StartMoving();
                self.isMoving = true;
            end
        end
    end)
lexf_expframe:SetScript("OnMouseUp", function(self, button)
    if button == "LeftButton" and self.isMoving and lexf_expframe:IsMovable() then
        self:StopMovingOrSizing();
        self.isMoving = false;
        local _, _, ebrelpoint, ebposx, ebposy = lexf_expframe:GetPoint();
        lexf_usercache['IconPosrel'] = ebrelpoint;
        lexf_usercache['IconPosx'] = ebposx;
        lexf_usercache['IconPosy'] = ebposy;
    end
end)

local lexf_petexpframe = CreateFrame("StatusBar", "Exp-frame", lexf_expframe, BackdropTemplateMixin and "BackdropTemplate")
lexf_petexpframe:SetSize(160,10)
lexf_petexpframe:SetOrientation("Horizontal")
lexf_petexpframe:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
lexf_petexpframe:SetStatusBarColor(0, 1, 0.5)
lexf_petexpframe:SetMinMaxValues(-1,100)
lexf_petexpframe:SetScript("OnEnter", function(self, motion)
    --lexf_GttCurrScale=GameTooltip:GetScale()
    lexf_pettooltip()
    end)
lexf_petexpframe:SetScript("OnLeave", function(self, motion)
    GameTooltip:Hide()
    --GameTooltip:SetScale(lexf_GttCurrScale)
    end)
lexf_petexpframe:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"});
lexf_petexpframe:SetPoint("TOP", 0, 14)
lexf_petexpframe:SetBackdropColor(0.1,0.1,0,1);

function lexf_setmove(swich)
    if swich then
        lexf_expframe:SetMovable(true)
        lexf_expframe:RegisterForDrag("LeftButton")
    else
        lexf_expframe:SetMovable(false)
        lexf_expframe:RegisterForDrag()
    end
end

local lexf_2goFrame = lexf_expframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
lexf_2goFrame:SetPoint("RIGHT",lexf_expframe,"RIGHT", -5, 0)
lexf_2goFrame:SetFont("Fonts\\ARIALN.TTF", lexf_fontsize, "OUTLINE")

local lexf_2goFrame1 = lexf_expframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
lexf_2goFrame1:SetPoint("RIGHT",lexf_expframe,"LEFT", 40, 0)
lexf_2goFrame1:SetFont("Fonts\\ARIALN.TTF", lexf_fontsize, "OUTLINE")

local lexf_pet2goFrame = lexf_petexpframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
lexf_pet2goFrame:SetPoint("CENTER",lexf_petexpframe,"CENTER",0,0)
lexf_pet2goFrame:SetFont("Fonts\\ARIALN.TTF", (lexf_fontsize - 1), "OUTLINE")
--lexf_2goFrame:Hide()

local name = UnitName("player")
local realm = GetRealmName("player")
local pl_mxp=UnitXPMax("player")
local pl_xp=UnitXP("player")
local pl_xplu=(pl_mxp - pl_xp)
local pl_rested=GetXPExhaustion()
local pl_t2go=0
local pl_restpct=0
local pl_lpctdone=0
if pl_mxp ~= 0
then
    pl_lpctdone=(math.floor(pl_xp*100/pl_mxp))
end
local petcurrXP = 0
local petnextXP = 0
local petlastXP = 0
local petlnextXP = 0
local petLastLevel = 0
local petm2go = 0
local petLastName = ""
if pl_rested ~= nil
then
    pl_restpct=(math.floor((10*(100*(pl_rested/pl_mxp)/1.5)))/10)
else
    pl_rested=0
    pl_restpct=0
end
local pl_green=(pl_restpct / 120)
local pl_red=(0.9 - (pl_restpct / 120))
lexf_expframe:SetValue(pl_restpct)
--lexf_expframe.Text:SetText(pl_restpct .."%")
lexf_expframe:SetBackdropColor(pl_red,pl_green,0,1);

function lexf_init()

    if lexf_usercache == nil
        then
        print('Lemmos ExpBar Init usercache')
        lexf_usercache ={}
    end
    
    if lexf_usercache['show'] == nil
        then
        lexf_usercache['show'] = true
    end

    if lexf_usercache['showpet'] == nil
        then
        lexf_usercache['showpet'] = true
    end

    if lexf_usercache['show'] then
        if lexf_usercache['showpet'] and select(2, UnitClass("player")) == "HUNTER" and ((lexf_wowv == 1) or (lexf_wowv == 2) or (lexf_wowv == 3)) then
            lexf_petexpframe:Show()
            lexf_pet2goFrame:Show()
        else
            lexf_petexpframe:Hide()
            lexf_pet2goFrame:Hide()
        end
	    lexf_expframe:Show()
	    lexf_2goFrame:Show()
	    lexf_2goFrame1:Show()
    else
        lexf_petexpframe:Hide()
        lexf_pet2goFrame:Hide()
        lexf_expframe:Hide()
        lexf_2goFrame:Hide()
        lexf_2goFrame1:Hide()
    end

    if lexf_usercache['IconPosrel'] == nil then
        lexf_usercache['IconPosrel'] = "CENTER"
    end

    if lexf_usercache['IconPosx'] == nil then
        lexf_usercache['IconPosx'] = 0
    end

    if lexf_usercache['IconPosy'] == nil then
        lexf_usercache['IconPosy'] = 0
    end

    lexf_expframe:SetPoint(lexf_usercache['IconPosrel'], lexf_usercache['IconPosx'], lexf_usercache['IconPosy'])

    if lexf_usercache['lock'] == nil
        then
        lexf_usercache['lock'] = false
    end

    if lexf_usercache['lock']
        then
        lexf_setmove(false)
    else
        lexf_setmove(true)
    end
-- cronly
    if lexf_usercache['cronly'] == nil
        then
        lexf_usercache['cronly'] = false
    end
--end cronly
	if lexf_globalCache == nil
	then
		print('Lemmos ExpBar Init global')
		lexf_globalCache = {
			experience = {}
		}
	end
	if lexf_globalCache['experience'] == nil
	then
		print('Lemmos ExpBar Init global realm')
		lexf_globalCache['experience'] = {}
	end
	if lexf_globalCache['experience'][realm] == nil
	then
		print('Lemmos ExpBar Init global realm')
		lexf_globalCache['experience'][realm] = {}
	end
	if lexf_globalCache['experience'][realm][name] == nil
	then
		print('Lemmos ExpBar Init global realm char')
		lexf_globalCache['experience'][realm][name] = {}
	end
	if lexf_globalCache['ttscale'] == nil
	then
		lexf_globalCache['ttscale'] = GameTooltip:GetScale()
	end
end

function lexf_refreshxp()
    pl_mxp=UnitXPMax("player")
    pl_xp=UnitXP("player")
    pl_xplu=(pl_mxp - pl_xp)
    pl_rested=GetXPExhaustion()
    --pl_lpctdone=(math.floor(pl_xp*100/pl_mxp))
    if pl_mxp ~= 0
    then
        pl_lpctdone=(math.floor(pl_xp*100/pl_mxp))
    end
    if pl_rested ~= nil and pl_mxp ~= nil and UnitLevel("player") < lexf_maxplayerlevel
    then
        pl_restpct=(math.floor((10*(100*(pl_rested/pl_mxp)/1.5)))/10)
        if IsResting() then
            pl_t2go=((math.floor(10*((((1.5*pl_mxp)-pl_rested)*150/(1.5*pl_mxp))/lexf_save_restinside)/3600))/10)
        else
            pl_t2go=((math.floor(10*((((1.5*pl_mxp)-pl_rested)*150/(1.5*pl_mxp))/lexf_save_restoutside)/3600))/10)
        end
        pl_green=(pl_restpct / 120)
        pl_red=(0.9 - (pl_restpct / 120))
        if pl_restpct > 100 then
            pl_restpct = 100
            pl_t2go = 0
        end
    else
        pl_t2go=0
        pl_rested=0
        pl_restpct=0
        pl_green=0
        pl_red=0
    end
    lexf_expframe:SetValue(pl_restpct)
--    lexf_expframe.Text:SetText(pl_restpct .."%")
    lexf_expframe:SetBackdropColor(pl_red,pl_green,0,1);
    if UnitLevel("player") == lexf_maxplayerlevel then
        lexf_2goFrame:SetText(lexf_txt_maxreached)
        lexf_2goFrame1:SetText("")
    else
        lexf_2goFrame:SetText(pl_xplu .. "/" .. pl_mxp)
        lexf_2goFrame1:SetText(pl_restpct .. "%")
    end
    local _, _, lexf_class = UnitClass("player")
    lexf_globalCache['experience'][realm][name] = {
        timestamp = time(),
        restpct = pl_restpct,
        mxp = pl_mxp,
        xp = pl_xp,
        rested = pl_rested,
        xplu = pl_xplu,
        isresting = IsResting(),
        PlayerLevel=UnitLevel("player"),
        PlayerClass=lexf_class,
    }

    --lexf_petexpframe:SetValue(petpct)
    --lexf_petexpframe.Text:SetText("Pet-Level: " .. UnitLevel("pet") .. " " .. petpct .. "%")

    if lexf_usercache['show'] and lexf_usercache['showpet'] and select(2, UnitClass("player")) == "HUNTER" and ((lexf_wowv == 1) or (lexf_wowv == 2) or (lexf_wowv == 3)) then
        --print(petcurrXP)
        if petLastLevel ~= 0 then
            petlastXP = petcurrXP
            --print(petlastXP)
            if (petLastLevel < UnitLevel("pet")) and (petLastName == GetUnitName("pet",false)) then
                petlastXP = petcurrXP - petnextXP
                print("|cff729FCF Lemmos Experience Bar: |r|cff16D2AE" .. lexp_txt_petcongrats .. GetUnitName("pet",false) .. lexp_txt_petreached1 .. "|r|cffEDD400" .. UnitLevel("pet") .."|r|cff16D2AE" .. lexp_txt_petreached2 .. "|r")
            end
        else
            petlastXP, petlnextXP = GetPetExperience();
        end
        petcurrXP, petnextXP = GetPetExperience();
        --print(petcurrXP)
        petLastLevel=UnitLevel("pet")
        petLastName=GetUnitName("pet",false)
        if ((petcurrXP - petlastXP) > 0) and (petlastXP ~= 0) then
            petm2go = ((math.floor((petnextXP-petcurrXP)/(petcurrXP - petlastXP)))+1)
            print("|cff729FCF Lemmos Experience Bar: |r|cff16D2AE" .. GetUnitName("pet",false) .. lexp_txt_petgets .. "|r|cffEDD400" .. (petcurrXP - petlastXP) .. "|r|cff16D2AE" .. lexp_txt_petexppoints .. "|r|cffEDD400" .. petm2go .. "|r|cff16D2AE" .. lexp_txt_petmobs2go .. "|r")
        end
        petpct=0
        if petnextXP ~= 0
        then
            petpct=(math.floor((petcurrXP*100)/petnextXP))
        end
    --    print(tostring(petpct))
    -- (UnitLevel("pet") == lexf_maxplayerlevel) or
        if (UnitLevel("pet") == 0) or (tostring(petpct) == '-nan(ind)') then
            lexf_petexpframe:Hide()
            lexf_pet2goFrame:Hide()
        else
            lexf_petexpframe:Show()
            lexf_pet2goFrame:Show()
            lexf_petexpframe:SetValue(petpct)
            lexf_pet2goFrame:SetText("Pet-Level: " .. UnitLevel("pet") .. "  |  " .. petpct .. "%")
        end
    else
        lexf_petexpframe:Hide()
        lexf_pet2goFrame:Hide()
    end
end

function lexf_ttpoc()

end

function lexf_tooltip()
	GameTooltip:SetOwner(lexf_expframe, "ANCHOR_TOPRIGHT");
	GameTooltip:SetText("Lemmos Experience Bar\n\n", nil, nil, nil, nil, 1);
    GameTooltip:AddDoubleLine((lexf_txt_amaxxp), (pl_xp .. "/" .. pl_mxp .. " (" .. pl_lpctdone .. "%)"), 0, 1, 1, 1, 1, 0.5)
	GameTooltip:AddDoubleLine((lexf_txt_pnl), (pl_xplu), 0, 1, 1, 1, 1, 0.5)
	GameTooltip:AddDoubleLine((lexf_txt_ehpct), (pl_restpct .. "%"), 0, 1, 1, pl_red, pl_green, 0.1)
    GameTooltip:AddDoubleLine((lexf_txt_h2go), (pl_t2go .. "h"), 0, 1, 1, pl_red, pl_green, 0.1)
    GameTooltip:AddDoubleLine((lexf_txt_ehpt), (pl_rested), 0, 1, 1, 1, 1, 0.5)
    GameTooltip:AddLine(("\n\n" .. lexf_txt_otherchars), 1, 1, 0)
    for lexf_save_expname, lexf_save_experience in pairs(lexf_globalCache) do
        if lexf_save_expname == "experience" then
            for lexf_save_ServerName, Server in pairs(lexf_save_experience) do
                if lexf_save_ServerName == realm then
                    GameTooltip:AddLine(("\n" .. lexf_save_ServerName), 0.5, 1, 0.5)
                    for lexf_save_CharName, Chars in pairs(Server) do
                        lexf_save_isresting = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['isresting']
                        lexf_save_xp = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['xp']
                        lexf_save_mxp = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['mxp']
                        lexf_save_rested = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['rested']
                        lexf_save_PlayerLevel = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['PlayerLevel']
                        lexf_save_timestamp = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['timestamp']
                        lexf_save_restpct = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['restpct']
                        lexf_pctcompl = (math.floor(lexf_save_xp*100/lexf_save_mxp))
                        lexf_class = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]["PlayerClass"]
                        if lexf_class == 1 then
                            lexf_save_ccol= "|cffC79C6E"
                        elseif lexf_class == 2 then
                            lexf_save_ccol= "|cffF48CBA"
                        elseif lexf_class == 3 then
                            lexf_save_ccol= "|cffAAD372"
                        elseif lexf_class == 4 then
                            lexf_save_ccol= "|cffFFF468"
                        elseif lexf_class == 5 then
                            lexf_save_ccol= "|cffFFFFFF"
                        elseif lexf_class == 6 then
                            lexf_save_ccol= "|cffC41E3A"
                        elseif lexf_class == 7 then
                            lexf_save_ccol= "|cff0070DD"
                        elseif lexf_class == 8 then
                            lexf_save_ccol= "|cff3FC7EB"
                        elseif lexf_class == 9 then
                            lexf_save_ccol= "|cff8788EE"
                        elseif lexf_class == 10 then
                            lexf_save_ccol= "|cff00FF98"
                        elseif lexf_class == 11 then
                            lexf_save_ccol= "|cffFF7C0A"
                        elseif lexf_class == 12 then
                            lexf_save_ccol= "|cffA330C9"
                        else
                            lexf_save_ccol= "|cffD3D7CF"
                        end
                        lexf_save_tfll = (time() - lexf_save_timestamp)
                        if (lexf_save_CharName .. "/" .. lexf_save_ServerName) ~= (name .."/" .. realm)
                        then
                            if lexf_save_isresting
                            then
                                lexf_save_colournr_red = 0
                                lexf_save_colournr_green = 1
                                lexf_save_colournr_blue = 1
                            else
                                lexf_save_colournr_red = 1
                                lexf_save_colournr_green = 0.5
                                lexf_save_colournr_blue = 0.5
                            end
                            if lexf_save_restpct < 100 and lexf_save_PlayerLevel < lexf_maxplayerlevel
                            then
                                if lexf_save_isresting
                                then
                                    lexf_save_restedcalc = ((lexf_save_tfll*lexf_save_restinside*lexf_save_mxp/100)+lexf_save_rested)
                                    lexf_save_t2go=((math.floor(10*((((1.5*lexf_save_mxp)-lexf_save_restedcalc)*150/(1.5*lexf_save_mxp))/lexf_save_restinside)/3600))/10)
                                else
                                    lexf_save_restedcalc = ((lexf_save_tfll*lexf_save_restoutside*lexf_save_mxp/100)+lexf_save_rested)
                                    lexf_save_t2go=((math.floor(10*((((1.5*lexf_save_mxp)-lexf_save_restedcalc)*150/(1.5*lexf_save_mxp))/lexf_save_restoutside)/3600))/10)
                                end
                                if lexf_save_restedcalc > (lexf_save_mxp*1.5) then
                                    lexf_save_t2go=0
                                    lexf_save_restedcalc = (lexf_save_mxp*1.5)
                                end
                                lexf_save_pctcalc=(math.floor((10*(100*(lexf_save_restedcalc/lexf_save_mxp)/1.5)))/10)
                            else
                                lexf_save_t2go=0
                                lexf_save_restedcalc = lexf_save_rested
                                lexf_save_pctcalc = lexf_save_restpct
                            end

                            lexf_save_green=(lexf_save_pctcalc / 120)
                            lexf_save_red=(0.9 - (lexf_save_pctcalc / 120))

                            if lexf_save_PlayerLevel < lexf_maxplayerlevel
                            then
                                GameTooltip:AddDoubleLine(("     " .. " (" .. lexf_save_PlayerLevel .. ") " .. lexf_save_ccol .. lexf_save_CharName .. "|r (" .. lexf_save_xp .. "/" .. lexf_save_mxp .. " | " .. lexf_pctcompl .. "%)"), (lexf_save_pctcalc .. "% | " .. lexf_save_t2go .. "h"), lexf_save_colournr_red, lexf_save_colournr_green, lexf_save_colournr_blue, lexf_save_red, lexf_save_green, 0)
                            end
                        end
                    end
                end
            end
            for lexf_save_ServerName, Server in pairs(lexf_save_experience) do
                if not lexf_usercache['cronly'] and lexf_save_ServerName ~= realm then
                    GameTooltip:AddLine(("\n" .. lexf_save_ServerName), 0.5, 1, 0.5)
                    for lexf_save_CharName, Chars in pairs(Server) do
                        lexf_save_isresting = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['isresting']
                        lexf_save_xp = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['xp']
                        lexf_save_mxp = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['mxp']
                        lexf_save_rested = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['rested']
                        lexf_save_PlayerLevel = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['PlayerLevel']
                        lexf_save_timestamp = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['timestamp']
                        lexf_save_restpct = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]['restpct']
                        lexf_pctcompl = (math.floor(lexf_save_xp*100/lexf_save_mxp))
                        lexf_save_tfll = (time() - lexf_save_timestamp)
                            lexf_class = lexf_globalCache[lexf_save_expname][lexf_save_ServerName][lexf_save_CharName]["PlayerClass"]
                            if lexf_class == 1 then
                                lexf_save_ccol= "|cffC79C6E"
                            elseif lexf_class == 2 then
                                lexf_save_ccol= "|cffF48CBA"
                            elseif lexf_class == 3 then
                                lexf_save_ccol= "|cffAAD372"
                            elseif lexf_class == 4 then
                                lexf_save_ccol= "|cffFFF468"
                            elseif lexf_class == 5 then
                                lexf_save_ccol= "|cffFFFFFF"
                            elseif lexf_class == 6 then
                                lexf_save_ccol= "|cffC41E3A"
                            elseif lexf_class == 7 then
                                lexf_save_ccol= "|cff0070DD"
                            elseif lexf_class == 8 then
                                lexf_save_ccol= "|cff3FC7EB"
                            elseif lexf_class == 9 then
                                lexf_save_ccol= "|cff8788EE"
                            elseif lexf_class == 10 then
                                lexf_save_ccol= "|cff00FF98"
                            elseif lexf_class == 11 then
                                lexf_save_ccol= "|cffFF7C0A"
                            elseif lexf_class == 12 then
                                lexf_save_ccol= "|cffA330C9"
                            else
                                lexf_save_ccol= "|cffD3D7CF"
                            end
                        if (lexf_save_CharName .. "/" .. lexf_save_ServerName) ~= (name .."/" .. realm)
                        then
                            if lexf_save_isresting
                            then
                                lexf_save_colournr_red = 0
                                lexf_save_colournr_green = 1
                                lexf_save_colournr_blue = 1
                            else
                                lexf_save_colournr_red = 1
                                lexf_save_colournr_green = 0.5
                                lexf_save_colournr_blue = 0.5
                            end
                            if lexf_save_restpct < 100 and lexf_save_PlayerLevel < lexf_maxplayerlevel
                            then
                                if lexf_save_isresting
                                then
                                    lexf_save_restedcalc = ((lexf_save_tfll*lexf_save_restinside*lexf_save_mxp/100)+lexf_save_rested)
                                    lexf_save_t2go=((math.floor(10*((((1.5*lexf_save_mxp)-lexf_save_restedcalc)*150/(1.5*lexf_save_mxp))/lexf_save_restinside)/3600))/10)
                                else
                                    lexf_save_restedcalc = ((lexf_save_tfll*lexf_save_restoutside*lexf_save_mxp/100)+lexf_save_rested)
                                    lexf_save_t2go=((math.floor(10*((((1.5*lexf_save_mxp)-lexf_save_restedcalc)*150/(1.5*lexf_save_mxp))/lexf_save_restoutside)/3600))/10)
                                end
                                if lexf_save_restedcalc > (lexf_save_mxp*1.5) then
                                    lexf_save_t2go=0
                                    lexf_save_restedcalc = (lexf_save_mxp*1.5)
                                end
                                lexf_save_pctcalc=(math.floor((10*(100*(lexf_save_restedcalc/lexf_save_mxp)/1.5)))/10)
                            else
                                lexf_save_t2go = 0
                                lexf_save_restedcalc = lexf_save_rested
                                lexf_save_pctcalc = lexf_save_restpct
                            end

                            lexf_save_green=(lexf_save_pctcalc / 120)
                            lexf_save_red=(0.9 - (lexf_save_pctcalc / 120))

                            if lexf_save_PlayerLevel < lexf_maxplayerlevel
                            then
                                GameTooltip:AddDoubleLine(("     " .. " (" .. lexf_save_PlayerLevel .. ") " .. lexf_save_ccol .. lexf_save_CharName .. "|r (" .. lexf_save_xp .. "/" .. lexf_save_mxp .. " | " .. lexf_pctcompl .. "%)"), (lexf_save_pctcalc .. "% | " .. lexf_save_t2go .. "h"), lexf_save_colournr_red, lexf_save_colournr_green, lexf_save_colournr_blue, lexf_save_red, lexf_save_green, 0)
                            end
                        end
                    end
                end
            end
        end
    end
    GameTooltip:SetScale(lexf_globalCache['ttscale'])
    GameTooltip:Show()
end

function lexf_pettooltip()
	GameTooltip:SetOwner(lexf_petexpframe, "ANCHOR_TOPRIGHT");
	GameTooltip:SetText("Lemmos Pet-Experience Bar\n", nil, nil, nil, nil, 1);
    GameTooltip:AddDoubleLine((GetUnitName("pet",false)), ("lv. " .. UnitLevel("pet")), 0.5, 1, 1, 1, 1, 0.5)
    GameTooltip:AddLine(" ", 1, 1, 1)
    GameTooltip:AddDoubleLine((lexp_txt_petttexp), (petcurrXP .. "/" .. petnextXP .. " (" .. petpct .. "%)"), 0, 1, 1, 1, 1, 0.5)
	if lexf_wowv < 3 then
	    GameTooltip:AddDoubleLine((lexp_txt_petttloyality), (GetPetLoyalty()), 0, 1, 1, 1, 1, 0.5)
	end
    --GameTooltip:SetScale(lexf_globalCache['ttscale'])
    GameTooltip:Show()
end

lexf_MainFrame:RegisterEvent("ADDON_LOADED")
lexf_MainFrame:RegisterEvent("PLAYER_LOGIN")
lexf_MainFrame:RegisterEvent("PLAYER_XP_UPDATE")
lexf_MainFrame:RegisterEvent("UPDATE_EXHAUSTION")
lexf_MainFrame:RegisterEvent("ZONE_CHANGED")
lexf_MainFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
lexf_MainFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
lexf_MainFrame:RegisterEvent("PLAYER_UPDATE_RESTING")
lexf_MainFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
lexf_MainFrame:RegisterEvent("UNIT_PET_EXPERIENCE")
--lexf_MainFrame:RegisterEvent("PET_UI_CLOSE")
lexf_MainFrame:RegisterEvent("PET_BAR_UPDATE")

function lexf_MainFrame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and arg1 == "Lemmos_ExpBar"
	then
		lexf_init()
        lexf_refreshxp()
    elseif event == "ZONE_CHANGED" or event == "ZONE_CHANGED_NEW_AREA" or event == "ZONE_CHANGED_INDOORS"
    then
        C_Timer.After(5, function() 
            lexf_refreshxp()
            if IsResting() then
                lexf_expframe:SetStatusBarColor(0, 1, 1)
            else
                lexf_expframe:SetStatusBarColor(0.5, 0.5, 0.5)
            end
        end)
    else
        lexf_refreshxp()
        if IsResting() then
            lexf_expframe:SetStatusBarColor(0, 1, 1)
        else
            lexf_expframe:SetStatusBarColor(0.5, 0.5, 0.5)
        end
    end
--    print("Lemmos ExpBar " .. event)
    
    if IsFlyableArea() then
        if (GetZoneText()=="Dalaran") then
            if (GetSubZoneText()=="Krasus' Landeplatz") or (GetSubZoneText()=="Die Violette Zitadelle") or (GetSubZoneText()=="Die Schattenseite") then
                ifa89 = true
            else
                ifa89 = false
            end
        else
            ifa89 = true
        end
    else 
        ifa89 = false
    end
    
end
lexf_MainFrame:SetScript("OnEvent", lexf_MainFrame.OnEvent);

SLASH_LEXPBAR1 = '/lexpbar'
function SlashCmdList.LEXPBAR(msg)
	if msg ~= nil and msg ~= ""
	then 
		if msg == 'reset' then
            lexf_expframe:SetMovable(false)
            lexf_usercache['IconPosrel'] = "CENTER"
            lexf_usercache['IconPosx'] = 0
            lexf_usercache['IconPosy'] = 0
            lexf_usercache['lock'] = false
            lexf_usercache['show'] = true
            lexf_usercache['cronly'] = false
            ReloadUI()
        elseif msg  == 'show' then
            if lexf_usercache['showpet'] and select(2, UnitClass("player")) == "HUNTER" and ((lexf_wowv == 1) or (lexf_wowv == 2) or (lexf_wowv == 3)) then
                lexf_petexpframe:Show()
                lexf_pet2goFrame:Show()
            else
                lexf_petexpframe:Hide()
                lexf_pet2goFrame:Hide()
            end
            lexf_expframe:Show()
            lexf_2goFrame:Show()
            lexf_2goFrame1:Show()
            lexf_usercache['show'] = true
        elseif msg  == 'hide' then
            lexf_petexpframe:Hide()
            lexf_pet2goFrame:Hide()
        	lexf_expframe:Hide()
            lexf_2goFrame:Hide()
            lexf_2goFrame1:Hide()
            lexf_usercache['show'] = false
        elseif msg  == 'lock'
            then
            if lexf_usercache['lock'] then
                lexf_setmove(true)
                lexf_usercache['lock'] = false
            else
                lexf_setmove(false)
                lexf_usercache['lock'] = true
            end
        elseif msg == "current" then
            if lexf_usercache['cronly'] then
                lexf_usercache['cronly'] = false
            else
                lexf_usercache['cronly'] = true
            end
		end
	else
       	InterfaceOptionsFrame_OpenToCategory(addonName)
	    InterfaceOptionsFrame_OpenToCategory(addonName);
	end
end

lexf_optionsFrame.name = addonName
lexf_optionsFrame:Hide()
lexf_optionsFrame:SetScript("OnShow", function(lexf_optionsFrame)
	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "lexfCheck" .. label, lexf_optionsFrame, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = label
		check.tooltipRequirement = description
		return check
	end

	local title = lexf_optionsFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText(addonName .. " -- v." .. LEXB_Version)

	local lexf_resetbutton = CreateFrame("Button", "lexf_resetbuttonFrame", lexf_optionsFrame, "UIPanelButtonTemplate")
	lexf_resetbutton:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
	lexf_resetbutton:SetScript("OnClick", function()
        lexf_expframe:SetMovable(false)
        lexf_usercache['IconPosrel'] = "CENTER"
        lexf_usercache['IconPosx'] = 0
        lexf_usercache['IconPosy'] = 0
        lexf_usercache['lock'] = false
        lexf_usercache['show'] = true
        lexf_usercache['cronly'] = false
        ReloadUI()
	end)
	
	lexf_resetbutton:SetText(lexf_txt_reset)
	lexf_resetbutton:SetWidth(250)	
    
	lexf_resetbutton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lexf_resetbutton, "ANCHOR_TOPRIGHT");
        	GameTooltip:SetText(lexf_txt_reset, nil, nil, nil, nil, 1);
        	GameTooltip:AddLine((lexf_txt_resetdesc), 1, 1, 1)
        	GameTooltip:Show()        	
	    end)
	lexf_resetbutton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
    
-- cdel
	local lexf_cdelbutton = CreateFrame("Button", "lexf_cdelbuttonFrame", lexf_optionsFrame, "UIPanelButtonTemplate")
	lexf_cdelbutton:SetPoint("TOP", lexf_resetbutton, "BOTTOM", 0, -8)
	lexf_cdelbutton:SetScript("OnClick", function()
        -- StaticPopupDialogs["LEXF_CCACHE"].text = "Delete all cached Data?"
        StaticPopup_Show("LEXF_CCACHE")        
	end)
	
	lexf_cdelbutton:SetText(lexf_txt_clearcache)
	lexf_cdelbutton:SetWidth(250)	

	lexf_cdelbutton:SetScript("OnEnter", function(self, motion)
        	GameTooltip:SetOwner(lexf_cdelbutton, "ANCHOR_TOPRIGHT");
        	GameTooltip:SetText(lexf_txt_clearcache, nil, nil, nil, nil, 1);
        	GameTooltip:AddLine((lexf_txt_clearcachedesc), 1, 1, 1)
        	GameTooltip:Show()        	
	    end)
	lexf_cdelbutton:SetScript("OnLeave", function(self, motion)
        	GameTooltip:Hide()
	    end)
-- end cdel	
	lexf_lock = newCheckbox(
		lexf_txt_lock,
		lexf_txt_lockdesc,
		function(self, value) 
		    lexf_usercache['lock'] = value
            if value then
                lexf_setmove(false)
            else
                lexf_setmove(true)
            end
		end)
	lexf_lock:SetChecked(lexf_usercache['lock'])
	lexf_lock:SetPoint("TOPLEFT", lexf_cdelbutton, "BOTTOMLEFT", 0, -8)
	
	lexf_show = newCheckbox(
		lexf_txt_show,
		lexf_txt_showdesc,
		function(self, value) 
		    lexf_usercache['show'] = value
		    if value then
                if lexf_usercache['showpet'] and select(2, UnitClass("player")) == "HUNTER" and ((lexf_wowv == 1) or (lexf_wowv == 2) or (lexf_wowv == 3)) then
                    lexf_petexpframe:Show()
                    lexf_pet2goFrame:Show()
                else
                    lexf_petexpframe:Hide()
                    lexf_pet2goFrame:Hide()
                end
                lexf_expframe:Show()
                lexf_2goFrame:Show()
                lexf_2goFrame1:Show()
	        else
                lexf_petexpframe:Hide()
                lexf_pet2goFrame:Hide()
            	lexf_expframe:Hide()
                lexf_2goFrame:Hide()
                lexf_2goFrame1:Hide()
            end
		end)
	lexf_show:SetChecked(lexf_usercache['show'])
	lexf_show:SetPoint("TOPLEFT", lexf_lock, "BOTTOMLEFT", 0, -8)
-- petbar
    lexf_showpet = newCheckbox(
		lexf_txt_showpet,
		lexf_txt_showpetdesc,
		function(self, value) 
		    lexf_usercache['showpet'] = value
		    if value then
                if lexf_usercache['show'] and select(2, UnitClass("player")) == "HUNTER" and ((lexf_wowv == 1) or (lexf_wowv == 2) or (lexf_wowv == 3)) then
                    lexf_petexpframe:Show()
                    lexf_pet2goFrame:Show()
                else
                    lexf_petexpframe:Hide()
                    lexf_pet2goFrame:Hide()
                end
	        else
                lexf_petexpframe:Hide()
                lexf_pet2goFrame:Hide()
            end
		end)
	lexf_showpet:SetChecked(lexf_usercache['showpet'])
	lexf_showpet:SetPoint("TOPLEFT", lexf_show, "BOTTOMLEFT", 8, -8)
-- petbar end
-- cronly	
	lexf_cronly = newCheckbox(
		lexf_txt_cronly,
		lexf_txt_cronlydesc,
		function(self, value) 
		    lexf_usercache['cronly'] = value
		end)
	lexf_cronly:SetChecked(lexf_usercache['cronly'])
	lexf_cronly:SetPoint("TOPLEFT", lexf_showpet, "BOTTOMLEFT", -8, -8)
-- end cronly

    lexf_TTSlider = CreateFrame("Slider", "MySliderGlobalName", lexf_optionsFrame, "OptionsSliderTemplate")
    lexf_TTSlider:SetWidth(400)
    lexf_TTSlider:SetHeight(20)
    lexf_TTSlider:SetOrientation('HORIZONTAL')
    lexf_TTSlider:SetPoint("TOPLEFT", lexf_cronly, "BOTTOMLEFT", 0, -16)
    lexf_TTSlider.tooltipText = lexf_txt_ttsizedesc
    _G[lexf_TTSlider:GetName() .. 'Low']:SetText('50%')
    _G[lexf_TTSlider:GetName() .. 'High']:SetText('150%')
    _G[lexf_TTSlider:GetName() .. 'Text']:SetText(lexf_txt_ttsize)
    lexf_TTSlider:SetMinMaxValues(50,150)
    lexf_TTSlider:SetValueStep(5)
    lexf_TTSlider:SetObeyStepOnDrag(true)
    lexf_TTSlider:SetValue((lexf_globalCache['ttscale']*100))
    _G[lexf_TTSlider:GetName() .. 'Text']:SetText(lexf_txt_ttsize .. lexf_TTSlider:GetValue() .. "%")
    --lexf_TTSlider:SetEnabled(true)
    
    lexf_TTSlider:SetScript("OnValueChanged", function(self,value,userInput)
--	if userInput then 
--		print("Manually set by the user")
--        print(lexf_TTSlider:GetValue())
--	else
--		print("Set from a script")
--	end
        _G[lexf_TTSlider:GetName() .. 'Text']:SetText(lexf_txt_ttsize .. lexf_TTSlider:GetValue() .. "%")
        lexf_globalCache['ttscale'] = (lexf_TTSlider:GetValue()/100)
    end)
    --print(lexf_TTSlider:GetValue())
    
	lexf_optionsFrame:SetScript("OnShow", nil)
end)
InterfaceOptions_AddCategory(lexf_optionsFrame)

function lexf_delete_global()
    lexf_globalCache = {
	    experience = {}
    }
    lexf_globalCache['experience'] = {}
    lexf_globalCache['experience'][realm] = {}
    lexf_globalCache['experience'][realm][name] = {}
    lexf_refreshxp()
end


StaticPopupDialogs["LEXF_CCACHE"] = {
	text = lexf_txt_confirmdel,
	button1 = ACCEPT,
	button2 = CANCEL,
	OnAccept = function() lexf_delete_global() end,
	timeout = 0,
	whileDead = 0,
	hideOnEscape = 1
}
